from Tkinter import *
from ATOM3Type import *
from ATOM3Boolean import *
from ATOM3Constraint import *
class CopyXSpecify (ATOM3Type):
   def __init__(self):
      ATOM3Type.__init__(self)
      self.Copy= None
      self.Specify= None

   def createComponents(self):
      if not self.Copy:
         self.Copy=ATOM3Boolean()
         self.Copy.setValue(('Copy from LHS', 0))
         self.Copy.config = 0
      if not self.Specify:
         self.Specify=ATOM3Constraint()
         self.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))

   def show(self, parent, parentWindowInfo=None):
      self.createComponents()
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Copy').grid(row=0,column=0,sticky=W)
      self.Copy.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      Label(self.containerFrame, text='Specify').grid(row=1,column=0,sticky=W)
      Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Specify)).grid(row=1,column=1,sticky=W)
      return self.containerFrame

   def toString(self):
      self.createComponents()
      return  self.Copy.toString()+' '+ self.Specify.toString()
   def getValue(self):
      self.createComponents()
      return (self.Copy.getValue(),self.Specify.getValue(),)

   def setValue(self, value):
      self.createComponents()
      self.Copy.setValue(value[0])
      self.Specify.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.Copy.writeConstructor2File(file, indent, objName+'.Copy', depth, generatingCode)
      self.Specify.writeConstructor2File(file, indent, objName+'.Specify', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      self.createComponents()
      self.Copy.writeValue2File(file, indent, objName+'.Copy', depth, generatingCode)
      self.Specify.writeValue2File(file, indent, objName+'.Specify', depth, generatingCode)

