# __GPSSBlock.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Integer import *
from ATOM3String import *
from graph_GPSSBlock import *
class GPSSBlock(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_GPSSBlock
      self.parent = parent
      self.Label=ATOM3String('L')
      self.keyword_= self.Label
      self.Type=ATOM3Enum(['Advance', 'Assign', 'Depart', 'Enter', 'Gate', 'Generate', 'Leave', 'Link', 'Logic', 'Mark', 'Priority', 'Queue', 'Release', 'SaveValue', 'Seize', 'Tabulate', 'Terminate', 'Test', 'Transfer', 'Unlink'], 0, 0)
      self.A=ATOM3String('')
      self.B=ATOM3String('')
      self.C=ATOM3String('')
      self.D=ATOM3String('')
      self.E=ATOM3String('')
      self.F=ATOM3String('')
      self.X=ATOM3String('')
      self.Comments=ATOM3String('')
      self.generatedAttributes = {'Type': ('ATOM3Integer', ),
                                  'A': ('ATOM3String', ),
                                  'B': ('ATOM3String', ),
                                  'C': ('ATOM3String', ),
                                  'D': ('ATOM3String', ),
                                  'E': ('ATOM3String', ),
                                  'F': ('ATOM3String', ),
                                  'Label': ('ATOM3String', ),
                                  'X': ('ATOM3String', ),
                                  'Comments': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Type').grid(row=0,column=0,sticky=W)
      Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Type)).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Type', 0, 2)
      Label(self.containerFrame, text='A').grid(row=1,column=0,sticky=W)
      self.A.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'A', 1, 2)
      Label(self.containerFrame, text='B').grid(row=2,column=0,sticky=W)
      self.B.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'B', 2, 2)
      Label(self.containerFrame, text='C').grid(row=3,column=0,sticky=W)
      self.C.show(self.containerFrame, parentWindowInfo).grid(row=3,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'C', 3, 2)
      Label(self.containerFrame, text='D').grid(row=4,column=0,sticky=W)
      self.D.show(self.containerFrame, parentWindowInfo).grid(row=4,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'D', 4, 2)
      Label(self.containerFrame, text='E').grid(row=5,column=0,sticky=W)
      self.E.show(self.containerFrame, parentWindowInfo).grid(row=5,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'E', 5, 2)
      Label(self.containerFrame, text='F').grid(row=6,column=0,sticky=W)
      self.F.show(self.containerFrame, parentWindowInfo).grid(row=6,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'F', 6, 2)
      Label(self.containerFrame, text='Label').grid(row=7,column=0,sticky=W)
      self.Label.show(self.containerFrame, parentWindowInfo).grid(row=7,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Label', 7, 2)
      Label(self.containerFrame, text='X').grid(row=8,column=0,sticky=W)
      self.X.show(self.containerFrame, parentWindowInfo).grid(row=8,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'X', 8, 2)
      Label(self.containerFrame, text='Comments').grid(row=9,column=0,sticky=W)
      Button( self.containerFrame, text = 'edit', command =  lambda x=self : ATOM3TypeDialog(x.containerFrame, x.Comments)).grid(row=9,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Comments', 9, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 10)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Type.toString()+' '+self.A.toString()+' '+self.B.toString()+' '+self.C.toString()+' '+self.D.toString()+' '+self.E.toString()+' '+self.F.toString()+' '+self.Label.toString()+' '+self.X.toString()+' '+self.Comments.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Type.getValue(),self.A.getValue(),self.B.getValue(),self.C.getValue(),self.D.getValue(),self.E.getValue(),self.F.getValue(),self.Label.getValue(),self.X.getValue(),self.Comments.getValue(),)

   def setValue(self, value):
      self.Type.setValue(value[0])
      self.A.setValue(value[1])
      self.B.setValue(value[2])
      self.C.setValue(value[3])
      self.D.setValue(value[4])
      self.E.setValue(value[5])
      self.F.setValue(value[6])
      self.Label.setValue(value[7])
      self.X.setValue(value[8])
      self.Comments.setValue(value[9])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Type.writeConstructor2File(file, indent, objName+'.Type', depth, generatingCode)
      self.A.writeConstructor2File(file, indent, objName+'.A', depth, generatingCode)
      self.B.writeConstructor2File(file, indent, objName+'.B', depth, generatingCode)
      self.C.writeConstructor2File(file, indent, objName+'.C', depth, generatingCode)
      self.D.writeConstructor2File(file, indent, objName+'.D', depth, generatingCode)
      self.E.writeConstructor2File(file, indent, objName+'.E', depth, generatingCode)
      self.F.writeConstructor2File(file, indent, objName+'.F', depth, generatingCode)
      self.Label.writeConstructor2File(file, indent, objName+'.Label', depth, generatingCode)
      self.X.writeConstructor2File(file, indent, objName+'.X', depth, generatingCode)
      self.Comments.writeConstructor2File(file, indent, objName+'.Comments', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Type.writeValue2File(file, indent, objName+'.Type', depth, generatingCode)
      self.A.writeValue2File(file, indent, objName+'.A', depth, generatingCode)
      self.B.writeValue2File(file, indent, objName+'.B', depth, generatingCode)
      self.C.writeValue2File(file, indent, objName+'.C', depth, generatingCode)
      self.D.writeValue2File(file, indent, objName+'.D', depth, generatingCode)
      self.E.writeValue2File(file, indent, objName+'.E', depth, generatingCode)
      self.F.writeValue2File(file, indent, objName+'.F', depth, generatingCode)
      self.Label.writeValue2File(file, indent, objName+'.Label', depth, generatingCode)
      self.X.writeValue2File(file, indent, objName+'.X', depth, generatingCode)
      self.Comments.writeValue2File(file, indent, objName+'.Comments', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Type.invalid() or self.A.invalid() or self.B.invalid() or self.C.invalid() or self.D.invalid() or self.E.invalid() or self.F.invalid() or self.Label.invalid() or self.X.invalid() or self.Comments.invalid() 

   def clone(self):
      cloneObject = GPSSBlock( self.parent )
      cloneObject.Type = self.Type.clone()
      cloneObject.A = self.A.clone()
      cloneObject.B = self.B.clone()
      cloneObject.C = self.C.clone()
      cloneObject.D = self.D.clone()
      cloneObject.E = self.E.clone()
      cloneObject.F = self.F.clone()
      cloneObject.Label = self.Label.clone()
      cloneObject.X = self.X.clone()
      cloneObject.Comments = self.Comments.clone()
      cloneObject.keyword_ = cloneObject.Label
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Type = other.Type
      self.A = other.A
      self.B = other.B
      self.C = other.C
      self.D = other.D
      self.E = other.E
      self.F = other.F
      self.Label = other.Label
      self.X = other.X
      self.Comments = other.Comments
      self.keyword_ = self.Label
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Type.destroy()
      self.A.destroy()
      self.B.destroy()
      self.C.destroy()
      self.D.destroy()
      self.E.destroy()
      self.F.destroy()
      self.Label.destroy()
      self.X.destroy()
      self.Comments.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.storeLabel(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT or actionID == self.CREATE:
         res = self.changeIcon(params)
         if res: return res
      if actionID == self.DISCONNECT:
         res = self.disconnectTransfer(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.changedLabel(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def changeIcon(self, params):
      if self.parent.editGGLabel: return
      tval =self.Type.getValue()
      tname=tval[0][tval[1]]
      cx, cy = self.graphObject_.x, self.graphObject_.y
      oldObject = self.graphObject_
      if tname == 'Generate':
         from graph_Generate import *
         self.graphObject_=graph_Generate(cx, cy, self)
      elif tname == 'Advance':
         from graph_Advance import *
         self.graphObject_=graph_Advance(cx, cy, self)
      elif tname == 'Transfer':
         from graph_Transfer import *
         self.graphObject_=graph_Transfer(cx, cy, self)
      elif tname == 'Terminate':
         from graph_Terminate import *
         self.graphObject_=graph_Terminate(cx, cy, self)
      elif tname == 'Assign':
         from graph_Assign import *
         self.graphObject_=graph_Assign(cx, cy, self)
      elif tname == 'Depart':
         from graph_Depart import *
         self.graphObject_=graph_Depart(cx, cy, self)
      elif tname == 'Enter':
         from graph_Enter import *
         self.graphObject_=graph_Enter(cx, cy, self)
      elif tname == 'Gate':
         from graph_Gate import *
         self.graphObject_=graph_Gate(cx, cy, self)
      elif tname == 'Leave':
         from graph_Leave import *
         self.graphObject_=graph_Leave(cx, cy, self)
      elif tname == 'Link':
         from graph_Link import *
         self.graphObject_=graph_Link(cx, cy, self)
      elif tname == 'Priority':
         from graph_Priority import *
         self.graphObject_=graph_Priority(cx, cy, self)
      elif tname == 'Queue':
         from graph_Queue import *
         self.graphObject_=graph_Queue(cx, cy, self)
      elif tname == 'Release':
         from graph_Release import *
         self.graphObject_=graph_Release(cx, cy, self)
      elif tname == 'SaveValue':
         from graph_SaveValue import *
         self.graphObject_=graph_SaveValue(cx, cy, self)
      elif tname == 'Seize':
         from graph_Seize import *
         self.graphObject_=graph_Seize(cx, cy, self)
      elif tname == 'Tabulate':
         from graph_Tabulate import *
         self.graphObject_=graph_Tabulate(cx, cy, self)
      elif tname == 'Unlink':
         from graph_Unlink import *
         self.graphObject_=graph_Unlink(cx, cy, self)
      elif tname == 'Mark':
         from graph_Mark import *
         self.graphObject_=graph_Mark(cx, cy, self)
      elif tname == 'Test':
         from graph_Test import *
         self.graphObject_=graph_Test(cx, cy, self)
      elif tname == 'Logic':
         from graph_Logic import *
         self.graphObject_=graph_Logic(cx, cy, self)
      self.graphObject_.connections = []+oldObject.connections
      oldObject.erase(self.parent,0)
      self.graphObject_.DrawObject(self.parent.UMLmodel, self.parent.editGGLabel)
      self.graphObject_.semanticObject = oldObject.semanticObject
      
      
      
      
      
      
      
      

   def disconnectTransfer(self, params):
      if self.Type.toString() == "Transfer" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.B.toString(): self.B.setValue("")
         elif params[0].Label.toString() == self.C.toString(): self.C.setValue("")
      elif self.Type.toString() == "Gate" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.B.toString(): self.B.setValue("")
      elif self.Type.toString() == "Test" and params[1] == "SOURCE":
         if params[0].Label.toString() == self.C.toString(): self.C.setValue("")
      return None
      
      
      
      

   def storeLabel(self, params):
      self.parent.oldLabel = self.Label.toString()
      return None
      
      
      
      
      
      

   def changedLabel(self, params):
      for conn in self.in_connections_:
        if conn.in_connections_[0].Type.toString() == "Transfer":
           if conn.in_connections_[0].B.toString() == self.parent.oldLabel: conn.in_connections_[0].B.setValue(self.Label.toString())
           if conn.in_connections_[0].C.toString() == self.parent.oldLabel: conn.in_connections_[0].C.setValue(self.Label.toString())
        elif conn.in_connections_[0].Type.toString() == "Gate":
           if conn.in_connections_[0].B.toString() == self.parent.oldLabel: conn.in_connections_[0].B.setValue(self.Label.toString())
        elif conn.in_connections_[0].Type.toString() == "Test":
           if conn.in_connections_[0].C.toString() == self.parent.oldLabel: conn.in_connections_[0].C.setValue(self.Label.toString())
      
      
      
      
      
      
      
      



