# __SNAVariable.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Enum import *
from graph_SNAVariable import *
class SNAVariable(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_SNAVariable
      self.parent = parent
      self.Name=ATOM3String('')
      self.keyword_= self.Name
      self.Type=ATOM3Enum(['Integer', 'Float', 'Boolean'], 0, 0)
      self.Expression=ATOM3String('')
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'Type': ('ATOM3Enum', ),
                                  'Expression': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Name').grid(row=0,column=0,sticky=W)
      self.Name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Name', 0, 2)
      Label(self.containerFrame, text='Type').grid(row=1,column=0,sticky=W)
      self.Type.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Type', 1, 2)
      Label(self.containerFrame, text='Expression').grid(row=2,column=0,sticky=W)
      self.Expression.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Expression', 2, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 3)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Name.toString()+' '+self.Type.toString()+' '+self.Expression.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Name.getValue(),self.Type.getValue(),self.Expression.getValue(),)

   def setValue(self, value):
      self.Name.setValue(value[0])
      self.Type.setValue(value[1])
      self.Expression.setValue(value[2])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Name.writeConstructor2File(file, indent, objName+'.Name', depth, generatingCode)
      self.Type.writeConstructor2File(file, indent, objName+'.Type', depth, generatingCode)
      self.Expression.writeConstructor2File(file, indent, objName+'.Expression', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Name.writeValue2File(file, indent, objName+'.Name', depth, generatingCode)
      self.Type.writeValue2File(file, indent, objName+'.Type', depth, generatingCode)
      self.Expression.writeValue2File(file, indent, objName+'.Expression', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Name.invalid() or self.Type.invalid() or self.Expression.invalid() 

   def clone(self):
      cloneObject = SNAVariable( self.parent )
      cloneObject.Name = self.Name.clone()
      cloneObject.Type = self.Type.clone()
      cloneObject.Expression = self.Expression.clone()
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Name = other.Name
      self.Type = other.Type
      self.Expression = other.Expression
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Name.destroy()
      self.Type.destroy()
      self.Expression.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


