from graphEntity        import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_SaveValue(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"smooth","self.semanticObject.", [], [])
        constObj.setValue(('smooth', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE OBJECT'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), 'self.gf6.setSmooth(1)\012self.gf7.setSmooth(1)\012'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([19.0, 29.0, 145.0, 59.0]), tags = self.tag, fill = "", outline = "black")
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_line(self.translate([20.0, 5.0, 2.0, 17.0, 20.0, 29.0]), tags = self.tag, fill = "black")
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_line(self.translate([147.0, 6.0, 21.0, 6.0]), tags = self.tag, fill = "black")
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        h = drawing.create_line(self.translate([146.0, 5.0, 166.0, 17.0, 144.0, 30.0]), tags = self.tag, fill = "black")
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_oval(self.translate([83.0, 7.0, 83.0, 7.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([81.0, 60.0, 81.0, 60.0]), tags = (self.tag, "connector"), fill = "red", outline = "black")
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.B.toString(25,5)
        else: drawText = "<B>"
        h = drawing.create_text(self.translate([81.0, 44.0]), tags = self.tag, text = drawText, fill = "blue")

        self.attr_display["B"] = h
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        if self.semanticObject: drawText = self.semanticObject.C.toString(25,5)
        else: drawText = "<C>"
        h = drawing.create_text(self.translate([123.0, 44.0]), tags = self.tag, text = drawText, fill = "blue")

        self.attr_display["C"] = h
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        if self.semanticObject: drawText = self.semanticObject.A.toString(25,5)
        else: drawText = "<A>"
        h = drawing.create_text(self.translate([40.0, 44.0]), tags = self.tag, text = drawText, fill = "blue")

        self.attr_display["A"] = h
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)

    def smooth(self):
       self.gf6.setSmooth(1)
       self.gf7.setSmooth(1)
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.smooth()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_SaveValue
