from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Table(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 251, 76
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([13.0, 1.0, 25.0, 14.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_rectangle(self.translate([13.0, 14.0, 25.0, 26.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_rectangle(self.translate([13.0, 26.0, 25.0, 38.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_text(self.translate([34.0, 20.0]), tags = self.tag, fill= 'black', anchor= 'w', font= 'Helvetica -12', text= 'Name:', justify= 'left', width= '0', stipple= '')
        self.gf11 = GraphicalForm(drawing, h, "gf11")
        self.graphForms.append(self.gf11)
        h = drawing.create_text(self.translate([34.0, 34.0]), tags = self.tag, fill= 'black', anchor= 'w', font= 'Helvetica -12', text= 'Low.Limit:', justify= 'left', width= '0', stipple= '')
        self.gf13 = GraphicalForm(drawing, h, "gf13")
        self.graphForms.append(self.gf13)
        h = drawing.create_text(self.translate([34.0, 48.0]), tags = self.tag, fill= 'black', anchor= 'w', font= 'Helvetica -12', text= 'Int.Size:', justify= 'left', width= '0', stipple= '')
        self.gf14 = GraphicalForm(drawing, h, "gf14")
        self.graphForms.append(self.gf14)
        h = drawing.create_text(self.translate([34.0, 62.0]), tags = self.tag, fill= 'black', anchor= 'w', font= 'Helvetica -12', text= 'Num.Intervals:', justify= 'left', width= '0', stipple= '')
        self.gf15 = GraphicalForm(drawing, h, "gf15")
        self.graphForms.append(self.gf15)
        h = drawing.create_rectangle(self.translate([13.0, 38.0, 25.0, 50.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf16 = GraphicalForm(drawing, h, "gf16")
        self.graphForms.append(self.gf16)
        h = drawing.create_rectangle(self.translate([13.0, 50.0, 25.0, 63.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf17 = GraphicalForm(drawing, h, "gf17")
        self.graphForms.append(self.gf17)
        h = drawing.create_rectangle(self.translate([13.0, 63.0, 25.0, 75.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf18 = GraphicalForm(drawing, h, "gf18")
        self.graphForms.append(self.gf18)
        h = drawing.create_rectangle(self.translate([28.0, 4.0, 170.0, 73.0]), tags = self.tag, fill= '', outline= 'black', width= '1.0', stipple= '')
        self.gf19 = GraphicalForm(drawing, h, "gf19")
        self.graphForms.append(self.gf19)
        if self.semanticObject: drawText = self.semanticObject.Label.toString(25,5)
        else: drawText = "<Label>"
        h = drawing.create_text(self.translate([119.0, 20.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'w', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Label"] = h
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        if self.semanticObject: drawText = self.semanticObject.Number_Of_Intervals.toString(25,5)
        else: drawText = "<Number_Of_Intervals>"
        h = drawing.create_text(self.translate([119.0, 62.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'w', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Number_Of_Intervals"] = h
        self.gf14 = GraphicalForm(drawing, h, "gf14")
        self.graphForms.append(self.gf14)
        if self.semanticObject: drawText = self.semanticObject.Lower_Limit.toString(25,5)
        else: drawText = "<Lower_Limit>"
        h = drawing.create_text(self.translate([119.0, 34.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'w', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Lower_Limit"] = h
        self.gf13 = GraphicalForm(drawing, h, "gf13")
        self.graphForms.append(self.gf13)
        if self.semanticObject: drawText = self.semanticObject.Interval_Size.toString(25,5)
        else: drawText = "<Interval_Size>"
        h = drawing.create_text(self.translate([119.0, 48.0]), tags = self.tag, text = drawText, fill= 'blue', anchor= 'w', font= 'Helvetica -12', justify= 'left', width= '0', stipple= '')
        self.attr_display["Interval_Size"] = h
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Table
