from ASG_PNMetaModel import *
from graph_ASG_ERmetaMetaModel import *
from Tkinter         import *
from ATOM3TypeInfo   import *
from ATOM3String     import *
from StatusBar       import *
from ATOM3TypeDialog import *

from PNPlace       import *
from PNTransition       import *
from pl2tran       import *
from tran2pl       import *
# Some constants for defining operation modes
NEWPNPlace = "NEWPNPlace"
NEWPNTransition = "NEWPNTransition"
NEWpl2tran = "NEWpl2tran"
NEWtran2pl = "NEWtran2pl"

def createNewASGroot(self):
    return ASG_PNMetaModel(self, None )

def createModelMenu(self, modelMenu):
    "Creates a customized Model Menu for the actual formalism"
    modelMenu = Menu(self.mmtoolMenu, tearoff=0)
    modelMenu.add_command(label="new PNPlace", command=lambda x=self: x.newModesPNPlace(x) )
    modelMenu.add_command(label="new PNTransition", command=lambda x=self: x.newModesPNTransition(x) )
    modelMenu.add_command(label="new pl2tran", command=lambda x=self: x.newModespl2tran(x) )
    modelMenu.add_command(label="new tran2pl", command=lambda x=self: x.newModestran2pl(x) )
def addButtons(self, createNewASGroot = 0):
    mmToolBar = Frame(self.toolBar, relief = RAISED)
    b = Label(mmToolBar, text = "PNMetaModel", font = ("Helvetica",8), relief = GROOVE)
    b.pack(side = TOP, fill = X, ipady = 5)
    self.openMetaModels.newItem(ATOM3String("PNMetaModel"))
    auxPanel = Frame(mmToolBar, relief = GROOVE)
    #import ImageTk
    bim = PhotoImage(file="Place.gif")
    self.UMLmodel.create_image(40, 80, image = bim)
    self.UMLmodel.create_text(10, 40, text = "hola")
    newPNPlace=Button(mmToolBar, image = bim, command=lambda x=self: x.newModePNPlace(x) )
    #newPNPlace=Label(mmToolBar, image = PhotoImage(file="Place2.gif", width=32, height=32))
    newPNPlace.pack(side=LEFT, padx=2, pady=2)

    newPNTransition=Button(mmToolBar, text="new PNTransition", command=lambda x=self: x.newModePNTransition(x) )
    newPNTransition.pack(side=LEFT, padx=2, pady=2)

    #newpl2tran=Button(mmToolBar, text="new pl2tran", command=lambda x=self: x.newModepl2tran(x) )
    #newpl2tran.pack(side=LEFT, padx=2, pady=2)

    #newtran2pl=Button(mmToolBar, text="new tran2pl", command=lambda x=self: x.newModetran2pl(x) )
    #newtran2pl.pack(side=LEFT, padx=2, pady=2)

    auxPanel.pack(side=TOP, fill=X, ipady=2)
    auxPanel = Frame(mmToolBar, relief = GROOVE)
    if createNewASGroot:
       self.ASGroot = ASG_PNMetaModel(self)
    self.buttonList.append((mmToolBar, "PNMetaModel"))
    return mmToolBar

def setConnectivity(self):
    self.ConnectivityMap['PNTransition']={
           'PNTransition': []
          ,'PNPlace': [( 'tran2pl', self.createNewtran2pl)] }
    self.ConnectivityMap['PNPlace']={
           'PNTransition': [( 'pl2tran', self.createNewpl2tran)]
          ,'PNPlace': [] }
    
    self.CardinalityTable['PNPlace']={
          'PNPlace': []
          ,'PNTransition': []
          ,'pl2tran': [('0', '1', 'Source')]
          ,'tran2pl': [] }
    self.CardinalityTable['PNTransition']={
          'PNPlace': []
          ,'PNTransition': []
          ,'pl2tran': []
          ,'tran2pl': [('1', '1', 'Source')] }
    self.CardinalityTable['pl2tran']={
          'PNPlace': [('1', '1', 'Destination')]
          ,'PNTransition': [('1', '1', 'Source')]
          ,'pl2tran': None
          ,'tran2pl': None }
    self.CardinalityTable['tran2pl']={
          'PNPlace': [('1', '1', 'Source')]
          ,'PNTransition': [('1', '1', 'Destination')]
          ,'pl2tran': None
          ,'tran2pl': None }
    
    self.entitiesInMetaModel['PNMetaModel']=['PNPlace', 'PNTransition', 'pl2tran', 'tran2pl']
    
def createNewPNPlace(self, wherex, wherey):
   self.fromClass = None
   self.toClass = None
   # try the global constraints...
   res = self.ASGroot.preCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   new_semantic_obj = PNPlace(self)
   ne = len(self.ASGroot.listNodes["PNPlace"])
   if new_semantic_obj.keyword_:
      new_semantic_obj.keyword_.setValue(new_semantic_obj.keyword_.toString()+str(ne))
   new_obj = graph_PNPlace(self.UMLmodel.canvasx(wherex), self.UMLmodel.canvasy(wherey), new_semantic_obj)
   new_obj.DrawObject(self.UMLmodel, self.editGGLabel)
   self.UMLmodel.addtag_withtag("PNPlace", new_obj.tag)
   new_semantic_obj.graphObject_ = new_obj
   self.ASGroot.addNode(new_semantic_obj)
   res = self.ASGroot.postCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   res = new_semantic_obj.postCondition(ASGNode.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   self.mode=self.IDLEMODE
   if self.editGGLabel :
      self.statusbar.event(StatusBar.TRANSFORMATION, StatusBar.CREATE)
   else:
      self.statusbar.event(StatusBar.MODEL, StatusBar.CREATE)
   return new_semantic_obj
def createNewPNTransition(self, wherex, wherey):
   self.fromClass = None
   self.toClass = None
   # try the global constraints...
   res = self.ASGroot.preCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   new_semantic_obj = PNTransition(self)
   ne = len(self.ASGroot.listNodes["PNTransition"])
   if new_semantic_obj.keyword_:
      new_semantic_obj.keyword_.setValue(new_semantic_obj.keyword_.toString()+str(ne))
   new_obj = graph_PNTransition(self.UMLmodel.canvasx(wherex), self.UMLmodel.canvasy(wherey), new_semantic_obj)
   new_obj.DrawObject(self.UMLmodel, self.editGGLabel)
   self.UMLmodel.addtag_withtag("PNTransition", new_obj.tag)
   new_semantic_obj.graphObject_ = new_obj
   self.ASGroot.addNode(new_semantic_obj)
   res = self.ASGroot.postCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   res = new_semantic_obj.postCondition(ASGNode.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   self.mode=self.IDLEMODE
   if self.editGGLabel :
      self.statusbar.event(StatusBar.TRANSFORMATION, StatusBar.CREATE)
   else:
      self.statusbar.event(StatusBar.MODEL, StatusBar.CREATE)
   return new_semantic_obj
def createNewpl2tran(self, wherex, wherey):
   self.fromClass = None
   self.toClass = None
   # try the global constraints...
   res = self.ASGroot.preCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   new_semantic_obj = pl2tran(self)
   ne = len(self.ASGroot.listNodes["pl2tran"])
   if new_semantic_obj.keyword_:
      new_semantic_obj.keyword_.setValue(new_semantic_obj.keyword_.toString()+str(ne))
   new_obj = graph_pl2tran(self.UMLmodel.canvasx(wherex), self.UMLmodel.canvasy(wherey), new_semantic_obj)
   new_obj.DrawObject(self.UMLmodel, self.editGGLabel)
   self.UMLmodel.addtag_withtag("pl2tran", new_obj.tag)
   new_semantic_obj.graphObject_ = new_obj
   self.ASGroot.addNode(new_semantic_obj)
   res = self.ASGroot.postCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   res = new_semantic_obj.postCondition(ASGNode.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   self.mode=self.IDLEMODE
   if self.editGGLabel :
      self.statusbar.event(StatusBar.TRANSFORMATION, StatusBar.CREATE)
   else:
      self.statusbar.event(StatusBar.MODEL, StatusBar.CREATE)
   return new_semantic_obj
def createNewtran2pl(self, wherex, wherey):
   self.fromClass = None
   self.toClass = None
   # try the global constraints...
   res = self.ASGroot.preCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   new_semantic_obj = tran2pl(self)
   ne = len(self.ASGroot.listNodes["tran2pl"])
   if new_semantic_obj.keyword_:
      new_semantic_obj.keyword_.setValue(new_semantic_obj.keyword_.toString()+str(ne))
   new_obj = graph_tran2pl(self.UMLmodel.canvasx(wherex), self.UMLmodel.canvasy(wherey), new_semantic_obj)
   new_obj.DrawObject(self.UMLmodel, self.editGGLabel)
   self.UMLmodel.addtag_withtag("tran2pl", new_obj.tag)
   new_semantic_obj.graphObject_ = new_obj
   self.ASGroot.addNode(new_semantic_obj)
   res = self.ASGroot.postCondition(ASG.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   res = new_semantic_obj.postCondition(ASGNode.CREATE)
   if res:
      self.constraintViolation(res)
      self.mode=self.IDLEMODE
      return

   self.mode=self.IDLEMODE
   if self.editGGLabel :
      self.statusbar.event(StatusBar.TRANSFORMATION, StatusBar.CREATE)
   else:
      self.statusbar.event(StatusBar.MODEL, StatusBar.CREATE)
   return new_semantic_obj
def createNew_Model(self, wherex, wherey):
   self.toClass = None
   self.fromClass = None
   new_semantic_obj = ASG_PNMetaModel(self)
   ne = len(self.ASGroot.listNodes["ASG_PNMetaModel"])
   if new_semantic_obj.keyword_:
      new_semantic_obj.keyword_.setValue(new_semantic_obj.keyword_.toString()+str(ne))
   new_obj = graph_ASG_ERmetaMetaModel(self.UMLmodel.canvasx(wherex), self.UMLmodel.canvasy(wherey), new_semantic_obj)
   new_obj.DrawObject(self.UMLmodel, self.editGGLabel)
   self.UMLmodel.addtag_withtag("ASG_PNMetaModel", new_obj.tag)
   new_semantic_obj.graphObject_ = new_obj
   self.ASGroot.addNode(new_semantic_obj)
   self.mode=self.IDLEMODE
   if self.editGGLabel :
      self.statusbar.event(StatusBar.TRANSFORMATION, StatusBar.CREATE)
   else:
      self.statusbar.event(StatusBar.MODEL, StatusBar.CREATE)
   return new_semantic_obj
def fillTypesInformation(self):
    objs = []
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("String", "ATOM3String", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    param = ATOM3String("None")
    params.append(param)
    param = ATOM3String("None")
    params.append(param)
    param = ATOM3String("1")
    params.append(param)
    obj.setValue(("Boolean", "ATOM3Boolean", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("Integer", "ATOM3Integer", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("Float", "ATOM3Float", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    param = ATOM3String("self.types")
    params.append(param)
    obj.setValue(("Attribute", "ATOM3Attribute", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    param = ATOM3String("[1,1,1,self.types]")
    params.append(param)
    param = ATOM3String("ATOM3Attribute")
    params.append(param)
    param = ATOM3String("self.types")
    params.append(param)
    obj.setValue(("List", "ATOM3List", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    param = ATOM3String("[]")
    params.append(param)
    param = ATOM3String("1")
    params.append(param)
    param = ATOM3String("1")
    params.append(param)
    obj.setValue(("Enum", "ATOM3Enum", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("Constraint", "ATOM3Constraint", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    param = ATOM3String("'class0'")
    params.append(param)
    param = ATOM3String("None")
    params.append(param)
    obj.setValue(("Appearance", "ATOM3Appearance", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("BottomType", "ATOM3BottomType", params, (None, 0) ))
    objs.append(obj)
    obj = ATOM3TypeInfo(self)
    params  = []
    obj.setValue(("Link", "ATOM3Link", params, (None, 0) ))
    objs.append(obj)
    self.typeList.setValue(objs)

