# __Server.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Integer import *
from ATOM3Port import *
from graph_Server import *
class Server(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Server
      self.parent = parent
      self.Name=ATOM3String('server_')
      self.keyword_= self.Name
      self.Capacity=ATOM3Integer(1)
      self.inport = []
      self.outport = []
      self.num_entities=ATOM3Integer(0)
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'Capacity': ('ATOM3Integer', ),
                                  'num_entities': ('ATOM3Integer', )      }
      self.realOrder = ['Name','Capacity','num_entities']
      self.directEditing = [1,1,1,1,1]
   def clone(self):
      cloneObject = Server( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


