# __Sink.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Port import *
from ATOM3Text import *
from ATOM3Integer import *
from graph_Sink import *
class Sink(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Sink
      self.parent = parent
      self.Name=ATOM3String('sink_')
      self.keyword_= self.Name
      self.inport = []
      self.Code=ATOM3Text('# enter the code for a single entity\n# which reaches this sink\n\nreturn None\n', 60,15 )
      self.num_entities=ATOM3Integer(0)
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'Code': ('ATOM3Text', ),
                                  'num_entities': ('ATOM3Integer', )      }
      self.realOrder = ['Name','Code','num_entities']
      self.directEditing = [1,1,1,1]
   def clone(self):
      cloneObject = Sink( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


