from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Generator(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 85, 64
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([17.0, 19.0, 57.0, 52.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_oval(self.translate([24.0, 24.0, 48.0, 43.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_line(self.translate([19.0, 34.0, 55.0, 34.0, 50.0, 28.0]), tags = self.tag, stipple= '', splinesteps= '12', arrowshape= '8 10 3', smooth= 0, joinstyle= 'round', width= '1.0', arrow= 'none', capstyle= 'butt', fill= 'black')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_line(self.translate([55.999999999999993, 34.0, 50.0, 39.0]), tags = self.tag, stipple= '', splinesteps= '12', arrowshape= '8 10 3', smooth= 0, joinstyle= 'round', width= '1.0', arrow= 'none', capstyle= 'butt', fill= 'black')
        self.gf10 = GraphicalForm(drawing, h, "gf10")
        self.graphForms.append(self.gf10)
        h = drawing.create_rectangle(self.translate([57.0, 28.0, 59.999999999999993, 41.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf13 = GraphicalForm(drawing, h, "gf13")
        self.graphForms.append(self.gf13)
        h = drawing.create_text(self.translate([68.0, 22.0]), tags = self.tag, stipple= '', fill= 'black', text= 'out', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_oval(self.translate([57.999999999999993, 34.0, 57.999999999999993, 34.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'blue')
        self.connectors.append(h)
        self.namedConnectors[h] = "outport"
        if self.semanticObject: drawText = self.semanticObject.num_entities.toString(25,5)
        else: drawText = "<num_entities>"
        h = drawing.create_text(self.translate([42.0, 13.0]), tags = self.tag, text = drawText, stipple= '', fill= 'red', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["num_entities"] = h
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([38.0, 56.999999999999993]), tags = self.tag, text = drawText, stipple= '', fill= 'blue', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["Name"] = h
        self.gf12 = GraphicalForm(drawing, h, "gf12")
        self.graphForms.append(self.gf12)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Generator
