from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Server(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 89, 68
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([24.0, 17.0, 63.0, 49.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf1 = GraphicalForm(drawing, h, "gf1")
        self.graphForms.append(self.gf1)
        h = drawing.create_oval(self.translate([34.0, 24.0, 56.0, 44.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf2 = GraphicalForm(drawing, h, "gf2")
        self.graphForms.append(self.gf2)
        h = drawing.create_rectangle(self.translate([21.0, 27.000000000000004, 25.0, 40.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_text(self.translate([16.000000000000004, 20.0]), tags = self.tag, stipple= '', fill= 'black', text= 'in', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.gf5 = GraphicalForm(drawing, h, "gf5")
        self.graphForms.append(self.gf5)
        h = drawing.create_text(self.translate([75.0, 21.0]), tags = self.tag, stipple= '', fill= 'black', text= 'out', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_rectangle(self.translate([61.0, 26.0, 65.0, 40.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_oval(self.translate([23.0, 34.0, 23.0, 34.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'blue')
        self.connectors.append(h)
        self.namedConnectors[h] = "inport"
        h = drawing.create_oval(self.translate([64.0, 33.0, 64.0, 33.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'blue')
        self.connectors.append(h)
        self.namedConnectors[h] = "outport"
        if self.semanticObject: drawText = self.semanticObject.num_entities.toString(25,5)
        else: drawText = "<num_entities>"
        h = drawing.create_text(self.translate([42.0, 10.0]), tags = self.tag, text = drawText, stipple= '', fill= 'red', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["num_entities"] = h
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        if self.semanticObject: drawText = self.semanticObject.Capacity.toString(25,5)
        else: drawText = "<Capacity>"
        h = drawing.create_text(self.translate([42.0, 33.0]), tags = self.tag, text = drawText, stipple= '', fill= 'blue', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["Capacity"] = h
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([43.999999999999993, 58.999999999999993]), tags = self.tag, text = drawText, stipple= '', fill= 'blue', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["Name"] = h
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Server
